using System;
using System.Net;
using System.Drawing;
using System.Net.Sockets;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using NetSystem;
using NetSystem.Client;

using ChatLibrary;

namespace ChatClient
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtText;
		private System.Windows.Forms.TextBox txtChatBox;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuFileDisconnect;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuFileConnect;
		private System.Windows.Forms.MenuItem menuFileOptions;
		private System.Windows.Forms.MenuItem menuFileExit;
		private System.Windows.Forms.MenuItem menuQuestion;
		private System.Windows.Forms.MenuItem menuQuestionInfo;
		private System.Windows.Forms.ListBox lsbUsers;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.StatusBarPanel statusBarPanel;
		
		private NetClient m_Client;
		private Options m_Options;
		private string newLine;
		private string m_MyName;

		public frmMain()
		{
			InitializeComponent();

			m_Client = new NetClient();
			m_Client.EventReceivedData += new ReceivedDataFromServer(m_Client_EventReceivedData);
			m_Client.EventDisconnected += new DisconnectedFromServer(m_Client_EventDisconnected);

			newLine = Environment.NewLine;
			m_Options = new Options("Alex", "localhost", 1234);
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtText = new System.Windows.Forms.TextBox();
			this.txtChatBox = new System.Windows.Forms.TextBox();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuFileConnect = new System.Windows.Forms.MenuItem();
			this.menuFileDisconnect = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuFileExit = new System.Windows.Forms.MenuItem();
			this.menuQuestion = new System.Windows.Forms.MenuItem();
			this.menuQuestionInfo = new System.Windows.Forms.MenuItem();
			this.lsbUsers = new System.Windows.Forms.ListBox();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.statusBarPanel = new System.Windows.Forms.StatusBarPanel();
			this.menuFileOptions = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel)).BeginInit();
			this.SuspendLayout();
			// 
			// txtText
			// 
			this.txtText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtText.Location = new System.Drawing.Point(0, 372);
			this.txtText.Name = "txtText";
			this.txtText.Size = new System.Drawing.Size(656, 20);
			this.txtText.TabIndex = 1;
			this.txtText.Text = "";
			this.txtText.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.txtText_KeyPress);
			// 
			// txtChatBox
			// 
			this.txtChatBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtChatBox.BackColor = System.Drawing.Color.White;
			this.txtChatBox.Location = new System.Drawing.Point(0, 0);
			this.txtChatBox.Multiline = true;
			this.txtChatBox.Name = "txtChatBox";
			this.txtChatBox.ReadOnly = true;
			this.txtChatBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtChatBox.Size = new System.Drawing.Size(528, 368);
			this.txtChatBox.TabIndex = 4;
			this.txtChatBox.Text = "";
			this.txtChatBox.WordWrap = false;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFile,
																					 this.menuQuestion});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFileConnect,
																					 this.menuFileDisconnect,
																					 this.menuFileOptions,
																					 this.menuItem4,
																					 this.menuFileExit});
			this.menuFile.Text = "&File";
			// 
			// menuFileConnect
			// 
			this.menuFileConnect.Index = 0;
			this.menuFileConnect.Text = "&Connect";
			this.menuFileConnect.Click += new System.EventHandler(this.menuFileConnect_Click);
			// 
			// menuFileDisconnect
			// 
			this.menuFileDisconnect.Enabled = false;
			this.menuFileDisconnect.Index = 1;
			this.menuFileDisconnect.Text = "Dis&connect";
			this.menuFileDisconnect.Click += new System.EventHandler(this.menuFileDisconnect_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 3;
			this.menuItem4.Text = "-";
			// 
			// menuFileExit
			// 
			this.menuFileExit.Index = 4;
			this.menuFileExit.Text = "E&xit";
			this.menuFileExit.Click += new System.EventHandler(this.menuFileExit_Click);
			// 
			// menuQuestion
			// 
			this.menuQuestion.Index = 1;
			this.menuQuestion.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuQuestionInfo});
			this.menuQuestion.Text = "&?";
			// 
			// menuQuestionInfo
			// 
			this.menuQuestionInfo.Index = 0;
			this.menuQuestionInfo.Text = "&Info";
			this.menuQuestionInfo.Click += new System.EventHandler(this.menuQuestionInfo_Click);
			// 
			// lsbUsers
			// 
			this.lsbUsers.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lsbUsers.Location = new System.Drawing.Point(536, 0);
			this.lsbUsers.Name = "lsbUsers";
			this.lsbUsers.Size = new System.Drawing.Size(120, 368);
			this.lsbUsers.TabIndex = 5;
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 393);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.statusBarPanel});
			this.statusBar.ShowPanels = true;
			this.statusBar.Size = new System.Drawing.Size(656, 24);
			this.statusBar.TabIndex = 6;
			// 
			// statusBarPanel
			// 
			this.statusBarPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel.Text = "Chat Client";
			this.statusBarPanel.Width = 640;
			// 
			// menuFileOptions
			// 
			this.menuFileOptions.Index = 2;
			this.menuFileOptions.Text = "&Options";
			this.menuFileOptions.Click += new System.EventHandler(this.menuFileOptions_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 417);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.txtChatBox);
			this.Controls.Add(this.txtText);
			this.Controls.Add(this.lsbUsers);
			this.Menu = this.mainMenu;
			this.Name = "frmMain";
			this.Text = "Chat Client";
			this.Closed += new System.EventHandler(this.frmMain_Closed);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void addText(string theText)
		{
			txtChatBox.AppendText(DateTime.Now.ToString("[hh:mm:ss] ") + theText + newLine);
		}

		private void disconnect(string theReason)
		{
			addText("Disconnected: " + theReason);

			menuFileConnect.Enabled = true;
			menuFileDisconnect.Enabled = false;
			lsbUsers.Items.Clear();
		}

		private void connect()
		{
			addText("Connected...");

			menuFileConnect.Enabled = false;
			menuFileDisconnect.Enabled = true;
			lsbUsers.Items.Add(m_MyName);
		}

		#region Event Handlers
		private void menuFileConnect_Click(object sender, System.EventArgs e)
		{
			try
			{
				m_MyName = m_Options.Username;

				m_Client.Connect(Dns.GetHostByName(m_Options.Server).AddressList[0], m_Options.Port);
				m_Client.SendData(new NetLogin(m_MyName));
				
				connect();
			}
			catch(SocketException ex)
			{
				MessageBox.Show("An Error occured by connecting: " + ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void menuFileDisconnect_Click(object sender, System.EventArgs e)
		{
			m_Client.Disconnect("bye");
			disconnect("bye");
		}

		private void m_Client_EventReceivedData(NetPacket thePacket)
		{
			if(thePacket is NetChatMessage)
			{
				NetChatMessage msg = (NetChatMessage) thePacket;
				addText(msg.Username + ": " + msg.Message);
			}
			else if(thePacket is NetUserJoin)
			{
				NetUserJoin msg = (NetUserJoin) thePacket;
				addText("User joined: " + msg.Username);
				lsbUsers.Items.Add(msg.Username);
			}
			else if(thePacket is NetUserLeft)
			{
				NetUserLeft msg = (NetUserLeft) thePacket;
				addText("User left: " + msg.Username + " (" + msg.Reason + ")");
				lsbUsers.Items.Remove(msg.Username);
			}
			else if(thePacket is NetUserList)
			{
				NetUserList msg = (NetUserList) thePacket;
				lsbUsers.Items.AddRange(msg.Userlist);
			}
		}

		private void m_Client_EventDisconnected(string theReason)
		{
			disconnect(theReason);
		}

		private void frmMain_Closed(object sender, System.EventArgs e)
		{
			if(m_Client.Connected)
			{
				m_Client.Disconnect("bye");
			}
		}

		private void txtText_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(e.KeyChar == 13 & m_Client.Connected)
			{
				try
				{
					m_Client.SendData(new NetMessage(txtText.Text));
					addText(m_MyName + ": " + txtText.Text);
				}
				catch(SocketException ex)
				{
					MessageBox.Show(ex.Message);
				}
			}
		}

		private void menuQuestionInfo_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Chat Client Test Program by Alexander Lcking\n\nVersion: " + Application.ProductVersion.ToString(), "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void menuFileExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void menuFileOptions_Click(object sender, System.EventArgs e)
		{
			FormOptions frmOptions = new FormOptions(m_Options);

			if(frmOptions.ShowDialog() == DialogResult.OK)
			{
				m_Options = frmOptions.Options;
			}
		}
		#endregion

		[MTAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}
	}
}