using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ChatClient
{
	public class FormOptions : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblOptions;
		private System.Windows.Forms.Label lblServer;
		private System.Windows.Forms.Label lblPort;
		private System.Windows.Forms.Label lblUsername;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.TextBox txtServer;
		private System.Windows.Forms.TextBox txtPort;
		private System.Windows.Forms.TextBox txtUsername;
		
		private Options m_Options;

		public FormOptions(Options theOptions)
		{
			InitializeComponent();

			m_Options = theOptions;

			txtUsername.Text = m_Options.Username;
			txtServer.Text = m_Options.Server;
			txtPort.Text = m_Options.Port.ToString();
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblOptions = new System.Windows.Forms.Label();
			this.lblServer = new System.Windows.Forms.Label();
			this.lblPort = new System.Windows.Forms.Label();
			this.lblUsername = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.txtServer = new System.Windows.Forms.TextBox();
			this.txtPort = new System.Windows.Forms.TextBox();
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// lblOptions
			// 
			this.lblOptions.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblOptions.ForeColor = System.Drawing.Color.SteelBlue;
			this.lblOptions.Location = new System.Drawing.Point(8, 8);
			this.lblOptions.Name = "lblOptions";
			this.lblOptions.Size = new System.Drawing.Size(112, 24);
			this.lblOptions.TabIndex = 0;
			this.lblOptions.Text = "Options";
			// 
			// lblServer
			// 
			this.lblServer.Location = new System.Drawing.Point(8, 72);
			this.lblServer.Name = "lblServer";
			this.lblServer.Size = new System.Drawing.Size(64, 23);
			this.lblServer.TabIndex = 1;
			this.lblServer.Text = "Server:";
			// 
			// lblPort
			// 
			this.lblPort.Location = new System.Drawing.Point(8, 96);
			this.lblPort.Name = "lblPort";
			this.lblPort.Size = new System.Drawing.Size(64, 23);
			this.lblPort.TabIndex = 2;
			this.lblPort.Text = "Port:";
			// 
			// lblUsername
			// 
			this.lblUsername.BackColor = System.Drawing.SystemColors.Control;
			this.lblUsername.Location = new System.Drawing.Point(8, 48);
			this.lblUsername.Name = "lblUsername";
			this.lblUsername.Size = new System.Drawing.Size(64, 23);
			this.lblUsername.TabIndex = 3;
			this.lblUsername.Text = "Username:";
			// 
			// btnOK
			// 
			this.btnOK.Location = new System.Drawing.Point(48, 128);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 4;
			this.btnOK.Text = "&OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(128, 128);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 5;
			this.btnCancel.Text = "&Cancel";
			// 
			// txtServer
			// 
			this.txtServer.Location = new System.Drawing.Point(72, 72);
			this.txtServer.Name = "txtServer";
			this.txtServer.Size = new System.Drawing.Size(128, 20);
			this.txtServer.TabIndex = 6;
			this.txtServer.Text = "";
			// 
			// txtPort
			// 
			this.txtPort.Location = new System.Drawing.Point(72, 96);
			this.txtPort.Name = "txtPort";
			this.txtPort.Size = new System.Drawing.Size(56, 20);
			this.txtPort.TabIndex = 7;
			this.txtPort.Text = "";
			// 
			// txtUsername
			// 
			this.txtUsername.Location = new System.Drawing.Point(72, 48);
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(128, 20);
			this.txtUsername.TabIndex = 8;
			this.txtUsername.Text = "";
			// 
			// FormOptions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(208, 157);
			this.Controls.Add(this.txtUsername);
			this.Controls.Add(this.txtPort);
			this.Controls.Add(this.txtServer);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.lblUsername);
			this.Controls.Add(this.lblPort);
			this.Controls.Add(this.lblServer);
			this.Controls.Add(this.lblOptions);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormOptions";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Options";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			try
			{
				m_Options.Port = int.Parse(txtPort.Text);
				m_Options.Username = txtUsername.Text;
				m_Options.Server = txtServer.Text;

				DialogResult = DialogResult.OK;
				Close();
			}
			catch(FormatException)
			{
				MessageBox.Show("The Port isn't valid!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		public Options Options
		{
			get { return m_Options; }
			set { m_Options = value; }
		}
	}
}