using System;
using System.Collections;

namespace NetSystem.Server.Collections
{
	internal class ClientCollection : CollectionBase
	{
		public Client this[int index]
		{
			get { return (Client) List[index]; }
			set { List[index] = value; }
		}

		public int Add(Client theClient)
		{
			return List.Add(theClient);
		}

		public void Remove(Client theClient)
		{
			List.Remove(theClient);
		}

		public int GetFreeClientId()
		{
			InnerList.Sort();

			for(int i = 0; i < List.Count; i++)
			{
				if(((Client)List[i]).ClientID != i + 1)
				{
					return i + 1;
				}
			}

			return List.Count + 1;
		}

		public Client GetClientByID(int theID)
		{
			foreach(Client c in List)
			{
				if(c.ClientID == theID)
				{
					return c;
				}
			}

			return null;
		}
	}
}